//---------------------------------------------------------------------------
//  CRC-16/CRC-32 unit. (CPP)
//  Copyright (c) 2000, 01 Mental Studio - http://msrc.126.com
//  Author : Raptor - raptorz@163.com
//---------------------------------------------------------------------------
unit CRC1632;

interface

Uses
    Classes, SysUtils;

Const
    cnCRC_16    = $8005;
    cnCRC_CCITT = $1021;
    cnCRC_32    = $04C10DB7;

Type
    PByte = ^Byte;

Function DataCRC16( aData : TMemoryStream; aPoly : Word     ) : Word;
Function DataCRC32( aData : TMemoryStream; aPoly : Cardinal ) : Cardinal;

Function StrCRC16( aStr : String; aPoly : Word     ) : Word;
Function StrCRC32( aStr : String; aPoly : Cardinal ) : Cardinal;

implementation

{$L crcd.obj}

Function  CRC_16( aData : PByte; aSize : Cardinal; aPoly : Word     ) : Word;     External;
Function  CRC_32( aData : PByte; aSize : Cardinal; aPoly : Cardinal ) : Cardinal; External;


Function DataCRC16( aData : TMemoryStream; aPoly : Word ) : Word;
Begin
	Result := CRC_16( aData.Memory, aData.Size, aPoly );
End;

Function DataCRC32( aData : TMemoryStream; aPoly : Cardinal ) : Cardinal;
Begin
	Result := CRC_32( aData.Memory, aData.Size, aPoly );
End;

Function StrCRC16( aStr : String; aPoly : Word ) : Word;
Begin
	Result := CRC_16( Pointer( PChar( aStr ) ), Length( aStr ), aPoly );
End;

Function StrCRC32( aStr : String; aPoly : Cardinal ) : Cardinal;
Begin
	Result := CRC_32( Pointer( PChar( aStr ) ), Length( aStr ), aPoly );
End;

end.
