//---------------------------------------------------------------------------
//  CRC-16/CRC-32 unit. (C)
//  Copyright (c) 2000, 01 Mental Studio - http://msrc.126.com
//  Author : Raptor - raptorz@163.com
//---------------------------------------------------------------------------
//
//  Ҫ Delphi 뱾Ԫ crc.obj ļ
//  bcc32 -c -pr -O2 -C -K -N- -k- -d -3 -r- crc.c
//  ֱΪ
//  -c  Ϊ obj ļ
//  -pr  Pascal  fastcall ÷ʽ
//  -O2 ŻѡΪ2
//  -C  Ƕע
//  -K  Ĭʹ޷ַ
//  -N- ջ
//  -k- ʹñ׼ջ
//  -d  ϲظַ
//  -3  ʹ 386 ָ
//  -r- δ֪^_^
//

//---------------------------------------------------------------------------
#include "crc.h"
//---------------------------------------------------------------------------

// ע⣺λһΪ1ȥ
// CRC-16    = X16 + X15 + X2 + X0
const unsigned short cnCRC_16    = 0x8005;
// CRC-CCITT = X16 + X12 + X5 + X0˵ 16 λ CRC ʽһҪ
const unsigned short cnCRC_CCITT = 0x1021;
// CRC-32    = X32 + X26 + X23 + X22 + X16 + X11 + X10 + X8 + X7 + X5 + X4 + X2 + X1 + X0
const unsigned long  cnCRC_32    = 0x04C10DB7;
//---------------------------------------------------------------------------

unsigned long Table_CRC[256]; // CRC 
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//   16 λ CRC 
void BuildTable16( unsigned short aPoly )
{
    unsigned short i, j;
    unsigned short nData;
    unsigned short nAccum;

    for ( i = 0; i < 256; i++ )
    {
        nData = ( unsigned short )( i << 8 );
        nAccum = 0;
        for ( j = 0; j < 8; j++ )
        {
            if ( ( nData ^ nAccum ) & 0x8000 )
                nAccum = ( nAccum << 1 ) ^ aPoly;
            else
                nAccum <<= 1;
            nData <<= 1;
        }
        Table_CRC[i] = ( unsigned long )nAccum;
    }
}
//---------------------------------------------------------------------------
//   16 λ CRC ֵ
//  aData Ϊݣ aSize ΪݴС aPoly Ϊ CRC ʽ
//  ֵΪ 16 λ CRC ֵ
unsigned short CRC_16( const unsigned char * aData, unsigned long aSize, unsigned short aPoly )
{
    unsigned long  i;
    unsigned short nAccum = 0;

    BuildTable16( aPoly );
    for ( i = 0; i < aSize; i++ )
        nAccum = ( nAccum << 8 ) ^ ( unsigned short )Table_CRC[( nAccum >> 8 ) ^ *aData++];
    return nAccum;
}
//---------------------------------------------------------------------------
//   32 λ CRC 
void BuildTable32( unsigned long aPoly )
{
    unsigned long i, j;
    unsigned long nData;
    unsigned long nAccum;

    for ( i = 0; i < 256; i++ )
    {
        nData = ( unsigned long )( i << 24 );
        nAccum = 0;
        for ( j = 0; j < 8; j++ )
        {
            if ( ( nData ^ nAccum ) & 0x80000000 )
                nAccum = ( nAccum << 1 ) ^ aPoly;
            else
                nAccum <<= 1;
            nData <<= 1;
        }
        Table_CRC[i] = nAccum;
    }
}
//---------------------------------------------------------------------------
//   32 λ CRC ֵ
//  aData Ϊݣ aSize ΪݴС aPoly Ϊ CRC ʽ
//  ֵΪ 32 λ CRC ֵ
unsigned long CRC_32( const unsigned char * aData, unsigned long aSize, unsigned long aPoly )
{
    unsigned long i;
    unsigned long nAccum = 0;

    BuildTable32( aPoly );
    for ( i = 0; i < aSize; i++ )
        nAccum = ( nAccum << 8 ) ^ Table_CRC[( nAccum >> 24 ) ^ *aData++];
    return nAccum;
}
//---------------------------------------------------------------------------

